#pragma once

#include <asl/integers.hpp>
#include <asl/status.hpp>

#define VK_NO_STDDEF_H
#define VK_NO_STDINT_H
#define VK_NO_PROTOTYPES
#include <vulkan.h>

#include "hk21/vulkan_loader/fns.hpp"

#define FN(NAME) extern PFN_##NAME NAME;
VULKAN_GLOBAL_FNS
VULKAN_INSTANCE_FNS
#undef FN

namespace vulkan_loader
{

asl::status load_global(PFN_vkGetInstanceProcAddr load_fn);
asl::status load_instance(PFN_vkGetInstanceProcAddr load_fn, VkInstance instance);

} // namespace vulkan_loader

