#include "hk21/vulkan_loader/api.hpp"

#define FN(NAME) PFN_##NAME NAME;
VULKAN_GLOBAL_FNS
VULKAN_INSTANCE_FNS
#undef FN

asl::status vulkan_loader::load_global(PFN_vkGetInstanceProcAddr load_fn)
{
    (void)load_fn;
    
    bool has_errors = false;
    
#define FN(NAME) \
    NAME = asl::bit_cast<PFN_##NAME>(load_fn(VK_NULL_HANDLE, #NAME)); \
    if (NAME == nullptr) \
    { \
        ASL_ASSERT(NAME != nullptr); \
        has_errors = true; \
    }
VULKAN_GLOBAL_FNS
#undef FN

    return has_errors ? asl::runtime_error() : asl::ok();
}

asl::status vulkan_loader::load_instance(PFN_vkGetInstanceProcAddr load_fn, VkInstance instance)
{
    (void)load_fn;
    
    bool has_errors = false;
    
#define FN(NAME) \
    NAME = asl::bit_cast<PFN_##NAME>(load_fn(instance, #NAME)); \
    if (NAME == nullptr) \
    { \
        ASL_ASSERT(NAME != nullptr); \
        has_errors = true; \
    }
VULKAN_INSTANCE_FNS
#undef FN

    return has_errors ? asl::runtime_error() : asl::ok();
}

